#ifndef __CS2CS_H__
#define __CS2CS_H__

//class for conversion between wgs84 and Slovenian Gauss-Krueger,
//using the proj.4 converter
class Cs2cs {
private:
	static bool isInitialized;
	static void ensureInit();

public:
	//convert GK in meters to WGS84 in degrees
	static bool gaussKrSloTowgs84(const double x, const double y, double &lon, double &lat);
	
	//convert WGS84 in degrees to GK in meters
	static bool wgs84ToGaussKrSlo(const double lon, const double lat, double &x, double &y);

	//de-allocate internal structures
	static void deInitialize();
};

#endif /* __CS2CS_H__ */
