#ifndef __XGISLIB_CLOUD_H__
#	define __XGISLIB_CLOUD_H__

#include <osg/Drawable>
#include <osg/Geometry>
#include <osg/Geode>
#include <osg/Group>
#include <osg/Object>
#include <osg/CopyOp>

#include <xgislib/storage.h>

#include <vector>

#include <time.h>

class Cloud : public osg::Group {

protected:
	int numParticles;
	int particleSize;
	float sizeX, sizeY, thickness;
	virtual void placeParticles();
	osg::Vec3f sunPosition;
	time_t startTime;
	WorldStorage *storage;

	
	
public:
	osg::Vec3f getLightColour(float altitude);

	Cloud(WorldStorage *_storage, int _numParticles, int _partSize,
		float _sizeX, float _sizeY, float _thick, const osg::Vec3f &_sunPos,
		time_t _startTime);
	virtual ~Cloud();

};

#endif /* !__XGISLIB_CLOUD_H__ */
