#ifndef __XGISLIB_CUMULUS_H__
#	define __XGISLIB_CUMULUS_H__

#include <xgislib/cloud.h>

#include <time.h>

class Cumulus : public Cloud {
public:
	Cumulus(WorldStorage *_storage, int _numParticles, int _partSize,
		float _sizeX, float _sizeY, float _thick, const osg::Vec3f &_sunPos,
		time_t _startTime, int _subClouds);

protected:
	int subClouds;
	virtual void placeParticles();
	
	osg::Vec4Array *shadeCloud(const osg::Vec3Array *vertices, bool far,
		const osg::Vec3f &lightColour, double azimuth, double altitude);
	void generateEllipsoid(float a, float b, float c, float deltaPhi,
		float deltaTheta, float offPercent, osg::Vec3Array *v);

	void generateFromFractal(float a, float b, float c,
		float deltaPhi, float deltaTheta, float offPercent, osg::Image *image,
		bool isNear, osg::Vec3Array *v);
	
	void getCloudColour(float altitude, osg::Vec3f &cloudHighlight, 
		osg::Vec3f &cloudShadow);
};

#endif /* !__XGISLIB_CUMULUS_H__ */

