#include "config.h"

#include <xgislib/xputils.h>
#include <xgislib/debugobserver.h>

void DebugObserver::createObserver(DebugObserver **ptr) {
	if(NULL == *ptr) {
		*ptr = new DebugObserver();
	}
}

DebugObserver::DebugObserver() {
	objectCount = 0;
	createdObjects = 0;
	deletedObjects = 0;
}

DebugObserver::~DebugObserver() {
}

void DebugObserver::objectDeleted (void *) {
	mutex.lock();
	objectCount--;
	deletedObjects++;
	mutex.unlock();
}

void DebugObserver::objectCreated() {
	mutex.lock();
	objectCount++;
	createdObjects++;
	mutex.unlock();	
}

void DebugObserver::report() {
	XGIS_LOG_INFO("Objects created: %d", createdObjects);
	XGIS_LOG_INFO("Objects deleted: %d", deletedObjects);
	XGIS_LOG_INFO("Live objects: %d", objectCount);
}
