#ifndef __XGISLIB_GPSTRACK_H__
#define __XGISLIB_GPSTRACK_H__

#include <osg/Vec3>
#include <osg/Referenced>

#include "xmlparser.h"

class GpsTrack : protected XmlParser, public osg::Referenced {
private:
	static const char typeName[];
	std::vector<osg::Vec3> points;
	float speed;

	osg::Vec3 parseTrkPt(xmlNodePtr node);
	
public:
	virtual const char *getTypeName() { return typeName; }

	bool parseGpx(const char *uri);
	bool parseGpx(const std::string &uri) {
		return parseGpx(uri.c_str());
	}

	void clear() {
		points.clear();
	}

	unsigned int getNumPoints() const {
		return points.size();
	}
	
	void addPoint(osg::Vec3 p);
	void addPoint(Coords::GaussKr gk);

	void setSpeed(float _speed) {
		speed = _speed;
	}
	float getSpeed() const {
		return speed;
	}
	std::vector<osg::Vec3>::const_iterator begin() const {
		return points.begin();
	}
	std::vector<osg::Vec3>::const_iterator end() const {
		return points.end();
	}	
};

#endif /* __XGISLIB_GPSTRACK_H__ */
