#ifndef __SOCALIB_POINTDATA_H__
#  define __SOCALIB_POINTDATA_H__

#include <vector>
#include <string>

#include <xgislib/coords.h>
#include <xgislib/vectors.h>

#include <osg/Vec3d>

namespace Pointdata {
	class Elevations {
  	private: 
		static bool getPointBaseData(const std::string &dirName);

	public:
		static float* getArea(Point ref, int width, int height, FILE *f);
		static float* getQuad(int u, int v, const std::string &baseDirName,
			int resolutionFactor);
		static int getQuadSize(const std::string &dirName);
		static double getMaxResolution(const std::string &dirName);
		static int getMinResolution(const std::string &dirName);
	};

	class FeatureInfo {
	public:
		static int getMarkerPositions(const std::string &URL,
			std::vector<osg::Vec3d> &list,
			std::vector<std::string> &list_labels);
		static void getSunPosition(Coords::GaussKr place, time_t when,
			double& azimuth, double& altitude);
		static void getMoonPosition(Coords::GaussKr place, time_t when, 
			double& azimuth, double& altitude);
	};
}

#endif /* __SOCALIB_POINTDATA_H__ */
