#ifndef __XGISLIB_RELATIVEALTITUDEGEOMETRY_H__
#define __XGISLIB_RELATIVEALTITUDEGEOMETRY_H__

#include <osg/Geode>
#include <osg/Array>
#include <osg/Geometry>
#include <xgislib/world.h>

class RelativeAltitudeGeometry : public osg::Geometry
{	
protected:
	~RelativeAltitudeGeometry();
	std::vector<float> originalHeights;
	osg::ref_ptr<World> worldReference;
	TerrainChangeHandler *heightChangeHandler;

public:
	RelativeAltitudeGeometry():originalHeights(NULL), worldReference(NULL){};
	RelativeAltitudeGeometry(const RelativeAltitudeGeometry& geometry, const osg::CopyOp& copyop=osg::CopyOp::SHALLOW_COPY);

	void saveOriginalState(World* world);
	void recalculateHeights(void);
};

#endif /* !__XGISLIB_RELATIVEALTITUDEGEOMETRY_H__ */
