#ifndef __XGISLIB_RELATIVEALTITUDEGROUP_H__
#define __XGISLIB_RELATIVEALTITUDEGROUP_H__

#include <xgislib/world.h>

#include <osg/PositionAttitudeTransform>

class RelativeAltitudeGroup : public osg::PositionAttitudeTransform {

friend class RAGroupTerrainChangeHandler;

protected:
	osg::ref_ptr<World> world;
	osg::Vec2f refPosition;
	float relAltitude;

	TerrainChangeHandler *heightChangeHandler;

	~RelativeAltitudeGroup();

	void recalculateAltitude();

public:
	RelativeAltitudeGroup(const osg::Vec2f &_refPosition, float _relAltitude, World *_world);	
};

#endif /* !__XGISLIB_RELATIVEALTITUDEGROUP_H__ */
