#include "config.h"

#include <OpenThreads/ScopedLock>

#include <xgislib/semaphore.h>

int Semaphore::post() {
	if(0 != semMutex.lock()) {
		return -1;
	}
	counter++;
	if(condition.signal() != 0) {
		semMutex.unlock();
		return -1;
	}
	semMutex.unlock();
	return 0;
}
	
int Semaphore::wait() {
	if(0 != semMutex.lock()) {
		return -1;
	}
	while(counter == 0) {
		if(0 != condition.wait(&semMutex)) {
			semMutex.unlock();
			return -1;
		}
	}
	counter--;
	semMutex.unlock();
	return 0;
}

int Semaphore::trywait() {
	int rv = -1;
	if(0 != semMutex.lock()) {
		return -1;
	}
	if(counter > 0) {
		counter--;
		rv = 0;
	}
	else {
		rv = -1;
	}
	semMutex.unlock();		
	return rv;
}
