#ifndef __XGISLIB_STRATUS_H__
#	define __XGISLIB_STRATUS_H__

#include <xgislib/cloud.h>
#include <osg/Geode>
#include <osg/Image>
#include <time.h>

class Stratus : public Cloud {
public:
	Stratus(WorldStorage *_storage, int _numParticles, int _partSize,
		float _sizeX, float _sizeY, float _thick, const osg::Vec3f &_sunPos,
		time_t _startTime, float _rangeMin, float _rangeMax);

	static osg::ref_ptr<osg::Image> stratusTexture;
	static osg::ref_ptr<osg::Geode> cloudNear;

protected:	
	float rangeMin;
	float rangeMax;
	virtual void placeParticles();
	osg::Geode *generateCloudFromImage(osg::Image *cloudMap);
	void getStratusColour(float altitude, float &colourHi, float &colourLow);
	void shadeCloud(osg::Image *image, float altitude);

};

#endif /* !__XGISLIB_STRATUS_H__ */
