#ifndef __XGISLIB_SUN_H__
#	define __XGISLIB_SUN_H__

#include <osg/Drawable>
#include <osg/Geometry>
#include <osg/Geode>
#include <osg/Group>
#include <osg/LightSource>

class Sun : public osg::Group {
protected:
	double azimuth, altitude;
	osg::ref_ptr<osg::PositionAttitudeTransform> sunPosition; 
	osg::ref_ptr<osg::Light> sunLight;
	osg::Vec3f detailRefPoint;
	osg::LightSource *sunLightSource;
	

public:
	Sun(time_t rawtime, osg::Vec3f _detailRefPoint);
	osg::PositionAttitudeTransform *setupSun(time_t rawtime);
	osg::Vec3d getSunPosition(time_t rawtime);
	void setSunPosition(time_t rawtime);
	osg::Vec4d getSunColour(time_t rawtime);
	
	void setLightBrightness();
	void setupLight();

	osg::LightSource *getLightSource() { return sunLightSource; }
};


#endif /* !__XGISLIB_SUN_H__ */
