#ifndef __XGISLIB_XGISIMGUTILS_H__
#	define __XGISLIB_XGISIMGUTILS_H__

#include <osg/Drawable>
#include <osg/Geometry>
#include <osg/Geode>
#include <osg/Image>

class XGisImage {
public:
	static osg::Vec4f getImageValue(osg::Image *image, int i, 
		int j, osg::Vec4f empty, bool wrap);

	static osg::Vec4f getImageValue(osg::Image *image, int i, 
		int j, osg::Vec4f empty);

	static void convolve(osg::Image *srcImage, int type);
	static void generateFractal(osg::Image *image, float randomRange, 
		bool opacity, bool wrap, bool low);
	static void smoothBorder(osg::Image *image, int margin, 
		float opacity, float goal);
	static void clampImage(osg::Image *image, float value);
	static void squareImage(osg::Image *image);
	static void squareRootImage(osg::Image *image);
	static void setGrayRange(osg::Image *image, float rangeMin, float rangeMax,
		bool checkRange);
	static void addPercentNoise(osg::Image *image, float amount);
	static void makeCircle(osg::Image *image);
	static void makeSunCircle(osg::Image *image);
	static void initImage(osg::Image *image);
	static void initImage(osg::Image *image, float f, float opacity);
	static void fixBorder(osg::Image *image);

	static void scaleImage(osg::Image *image, int newSizeX, int newSizeY);
};

#endif /* !__XGISLIB_XGISIMGUTILS_H__ */
