#ifndef OBSCENE_XMLPARSER_H
#  define OBSCENE_XMLPARSER_H 

#include <string>
#include <vector>

#include <libxml/xmlreader.h>
#include "coords.h"

class XmlParser
{
protected:
	xmlDocPtr doc;
	
public:
	XmlParser(void);
	bool parse(std::string uri);
	std::string getNodeAttrValue(std::string nodeName, std::string attrName);
	int getListNodeAttrVals(std::string nodeName, std::string attrName,
		std::vector<std::string> &list);

public:
	~XmlParser(void);
	
protected:
	xmlNodePtr getChild(std::string name);
	xmlNodePtr getChild(xmlNodePtr parent, std::string name);
	void traverseNodeVals(xmlNodePtr root, std::string nodeName,
		std::string attrName, std::vector<std::string> &list);
};

#endif /* OBSCENE_XMLPARSER_H */
