#ifndef __OBSCENE_INTERACTIVEMANIPULATOR_H__
#	define __OBSCENE_INTERACTIVEMANIPULATOR_H__

#include "obscenemanipulator.h"
#include "hud.h"

class InteractiveManipulator : public ObsceneManipulator {

protected:
	// a HUD instance for reporting
	osg::ref_ptr<HUD> hud;

	float _mX, _mY;
	float shift, ctrl;
	bool _usePolytopeIntersector;
	bool _useWindowCoordinates;    

	bool handleKeyDown(const osgGA::GUIEventAdapter& ea,
		osgGA::GUIActionAdapter& us);
	bool handleMouseButton(const osgGA::GUIEventAdapter& ea,
		osgGA::GUIActionAdapter& us, bool doubleClick);
	
	osgUtil::IntersectionVisitor *createIV(const osgGA::GUIEventAdapter &ea);

	int executePickActions
		(const osgUtil::LineSegmentIntersector::Intersection &intersection,
			const osgGA::GUIEventAdapter &ea, bool doubleClick);
	void displayIntersectionLocation
		(const osgUtil::LineSegmentIntersector::Intersection &intersection);
	void moveToTerrainAtIntersection
		(const osgUtil::LineSegmentIntersector::Intersection &intersection,
			const osgGA::GUIEventAdapter &ea);

	bool pickOnScene(osgUtil::IntersectionVisitor *iv,
		const osgGA::GUIEventAdapter& ea, bool doubleClick);
	bool pickOnHUDMap(osgUtil::IntersectionVisitor *iv,
		const osgGA::GUIEventAdapter& ea, bool doubleClick);
		//check if the pick was on the overlay map;
		//if yes, process it & return true
		//otherwise return false

public:
	InteractiveManipulator(World *_world, ObsViewer *_viewer, HUD *_hud,
		const osg::Matrixd &_home);
	virtual ~InteractiveManipulator();
	
	virtual bool handle(const osgGA::GUIEventAdapter& ea, osgGA::GUIActionAdapter& us);

};

#endif /* !__OBSCENE_INTERACTIVEMANIPULATOR_H__ */
