#ifndef __OBSCENE_SKYDOME__
#	define __OBSCENE_SKYDOME__


#include <xgislib/storage.h>
#include <xgislib/world.h>

#include <osg/PositionAttitudeTransform>

class SkyDome : public osg::Group
{
public:
	SkyDome(osg::Vec3 _center, float radius, WorldStorage *storage, World* _world,
	int _turbidity, time_t rawtime);

	virtual ~SkyDome(void);
	int turbidity;
	
	World* world;
	void setSkyColour(time_t rawtime);

	void setCenter(const osg::Vec3 &_center);

private:
	osg::ref_ptr<osg::Node> skydome;
	osg::ref_ptr<osg::Geode> skyDomeGeode;
	double getZenithY(double theta);
	double getZenith_x(double theta);
	double getZenith_y(double theta);
	double getZenith(double theta, char type);
	osg::PositionAttitudeTransform *createSphere(osg::Vec3 center, float radius, WorldStorage *storage, time_t rawtime);
	void YxyToRGB(double Y, double x, double y, double& r, double& g, double& b);
	double fPerez(int turbididty, char type, double theta, double gamma);
	double thetaSun;
	double phiSun;
	double zenith_x, zenith_y, zenithY;
	osg::ref_ptr<osg::Vec3Array> vertices;
	osg::ref_ptr<osg::Geometry> skyGeometry;
	osg::Vec3d center;
	osg::ref_ptr<osg::PositionAttitudeTransform> transform; 
};

#endif
