#include "config.h"

#include "tree.h"

#include <osg/ShapeDrawable>

using namespace osg;

Tree::Tree() {
	geode = new Geode();
	//addChild(geode.get());
	//placeTree(location);
	location = osg::Vec3(0, 0, 0);

	initTreeTrunk(1.0f, 5.0f);
	initTreeTop(2.0f, 2.0f);
	
	//addChild(treePlacer);	
}

void Tree::initTreeTrunk(float radius, float height){
	osg::Cylinder* treeStump = new osg::Cylinder(location, radius, height);

	osg::ref_ptr<osg::ShapeDrawable> treeStumpShape = new osg::ShapeDrawable(treeStump);
	treeStumpShape->setColor(Vec4(0, 0.39f, 0, 1.0f));
	geode->addDrawable(treeStumpShape.get());
}

void Tree::initTreeTop(float radius, float height){
	osg::Capsule* treeTop = new osg::Capsule(location + osg::Vec3(0, 0, 4.5f), radius, height);

	osg::ref_ptr<osg::ShapeDrawable> treeTopShape = new osg::ShapeDrawable(treeTop);
	treeTopShape->setColor(Vec4(0, 0.55f, 0.27f, 1.0f));
	geode->addDrawable(treeTopShape.get());
}

osg::PositionAttitudeTransform* Tree::placeTree(osg::Vec3 location){
	treePlacer = new osg::PositionAttitudeTransform();
	treePlacer->addChild(geode.get());

	treePlacer->setPosition(location);

	return treePlacer;
}
