#ifndef __OBSCENE_WX_UI_H__
#	define __OBSCENE_WX_UI_H__

#include <wx/defs.h>
#include <wx/app.h>
#include <wx/cursor.h>
#include <wx/glcanvas.h>

#include "xgisui.h"
#include "obsviewer.h"
#include "wx/sizer.h"
#include "wx/choice.h"
#include "wx/checkbox.h"

class WxUI : public XGisUI {
	friend class WxUIApp;
	friend class WxUIGraphicsWindow;
	friend class WxUIMainFrame;

	wxFrame *frame;
	osgViewer::GraphicsWindow *gw;

public:
	virtual void setupViewer();
	virtual void run();
};


class WxMultiChoice;

class WxMultiData : public wxBoxSizer, wxEvtHandler
{
	public:
		WxMultiData(wxWindow *parent);
		wxWindow* GetParent(){	return this->parent;	};
		void DataChanged(int id);

	private:
		wxWindow* parent;
		WxMultiChoice* area;
		WxMultiChoice* level;
		wxCheckBox* relative;
		osg::Node *current;

};

class WxMultiChoice : public wxChoice
{
	public:
		WxMultiChoice(WxMultiData *p_parent, wxArrayString& choices) :
		  wxChoice(p_parent->GetParent(), wxID_ANY, wxDefaultPosition, wxDefaultSize, choices)
		{
			this->parent = p_parent;
			this->id=0;
		}
		void SetID(int p_id){   this->id = p_id;    };
		int  GetID(void)    {   return this->id;    };

        void OnChoice(wxCommandEvent& WXUNUSED(event));

	private:
		DECLARE_EVENT_TABLE()
		int id;
		WxMultiData* parent;
};

class WxCheckRelative : public wxCheckBox
{
	public:
		WxCheckRelative(WxMultiData *p_parent, wxWindowID id, const wxString &label) :
		  wxCheckBox(p_parent->GetParent(), id, label)
		{
			this->parent = p_parent;
			this->id=2;
		}
		void SetID(int p_id){   this->id = p_id;    };
		int  GetID(void)    {   return this->id;    };

        void OnClick(wxCommandEvent& WXUNUSED(event));

	private:
		DECLARE_EVENT_TABLE()
		int id;
		WxMultiData* parent;
};

#endif /* !__OBSCENE_WX_UI_H__ */
